#ifndef PIZZASTORE_H_
#define PIZZASTORE_H_

#include <iostream>
#include "Pizza.h"

enum class Type { CHEESE, VEGGIE, CLAM, PEPPERONI };

class PizzaStore
{
public:
    virtual ~PizzaStore() {}

    virtual Pizza *create_pizza(const Type type) = 0;

    Pizza *order_pizza(const Type type)
    {
        Pizza *pizza = create_pizza(type);
        cout << "--- Making a " << pizza->get_name() << " ---" << endl;

        pizza->prepare();
        pizza->bake();
        pizza->cut();
        pizza->box();

        return pizza;
    }
};

#endif /* PIZZASTORE_H_ */
